/*
 * Copyright (c) 1990-1991 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Lawrence Berkeley Laboratory,
 * Berkeley, CA.  The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifndef lint
static char rcsid[] =
    "@(#) $Header: midi_open.c,v 1.2 91/08/20 21:49:25 mccanne Exp $ (LBL)";
#endif

#include <errno.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sundev/midi.h>

int
midi_open(flag, port)
	int flag;
	int port;
{
	register int fd;
	register int n = 0;
	char device[sizeof("/dev/midi000")];
	/*
	 * Go through all the minors and find one that isn't in use.
	 */
	do {
		(void)sprintf(device, "/dev/midi%d", n++);
		fd = open(device, flag);
	} while (fd < 0 && errno == EBUSY);

	if (fd < 0) {
		perror(device);
		exit(1);
	}
	if (ioctl(fd, BMDATTACH, (char *)&port) < 0) {
		perror("BMDATTACH");
		exit(1);
	}
	return fd;
}

