/*
 * Copyright (c) 1990 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Lawrence Berkeley Laboratory,
 * Berkeley, CA.  The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * mwsel - test write side select support
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/file.h>
#include <sys/fcntl.h>
#include <errno.h>
#include <signal.h>
#include <sys/ioctl.h>
#include <sundev/midi.h>

#ifndef lint
static char rcsid[] =
    "@(#) $Header: mwsel.c,v 1.1 91/08/22 12:23:25 mccanne Exp $";
#endif

usage()
{
	fprintf(stderr, "Usage: mwsel [-d delta] [-p port]\n");
	exit(1);
}

#define DELTA 50

main(argc, argv)
	int argc;
	char **argv;
{
	int fd, cc, c, port;
	struct midi_msg mm;
	int aflag = 0;
	fd_set fds, fdinit;
	int delta = DELTA;

	extern char *optarg;

	port = 1;
	while ((c = getopt(argc, argv, "d:p:")) != -1) {
		switch(c) {

		case 'p':
			port = atoi(optarg);
			break;

		case 'd':
			delta = atoi(optarg);
			break;

		default:
			usage();
		}
	}
	fd = midi_open(O_WRONLY, port);

	FD_ZERO(&fdinit);
	FD_SET(fd, &fdinit);
	mm.mm_time = 0;
	mm.mm_data[0] = 0xfe;
	while (1) {
		fds = fdinit;
		if (select(fd + 1, 0, &fds, 0, 0) < 0) {
			perror("select");
			exit(1);
		}
		cc = write(fd, &mm, sizeof mm);
		if (cc < 0) {
			perror("read");
			exit(-1);
		}
		printf("write %08x\n", mm.mm_time);
		mm.mm_time += DELTA;
	}
}
