/*
 * Copyright (c) 1990-1991 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Lawrence Berkeley Laboratory,
 * Berkeley, CA.  The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <stdio.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sundev/midi.h>

struct midi_msg scale[] = {
	{ 0, { 0x90, 0x40, 0x40 } },
	{ 250, { 0x90, 0x40, 0x0 } },
	{ 250, { 0x90, 0x42, 0x40 } },
	{ 500, { 0x90, 0x42, 0x0 } },
	{ 500, { 0x90, 0x44, 0x40 } },
	{ 750, { 0x90, 0x44, 0x0 } },
	{ 750, { 0x90, 0x45, 0x40 } },
	{ 1000, { 0x90, 0x45, 0x0 } },
	{ 1000, { 0x90, 0x47, 0x40 } },
	{ 1250, { 0x90, 0x47, 0x0 } },
	{ 1250, { 0x90, 0x49, 0x40 } },
	{ 1500, { 0x90, 0x49, 0x0 } },
	{ 1500, { 0x90, 0x4b, 0x40 } },
	{ 1750, { 0x90, 0x4b, 0x0 } },
	{ 1750, { 0x90, 0x4c, 0x40 } },
	{ 2000, { 0x90, 0x4c, 0x0 } },
};

usage()
{
	fprintf(stderr, "usage: scale [-p port]\n");
	exit(1);
}

main(argc, argv)
	int argc;
	char **argv;
{
	int fd, i, cc, c;
	u_long mtime;
	int port = 1;

	extern char *optarg;

	while ((c = getopt(argc, argv, "p:")) != -1) {
		switch(c) {

		case 'p':
			port = atoi(optarg);
			break;

		default:
			usage();
		}
	}
	fd = midi_open(O_WRONLY, port);
	cc = write(fd, (caddr_t)&scale, sizeof scale);
	if (cc < 0) {
		perror("write");
		exit(1);
	}
	close(fd);
	return 0;
}
