/*
 * Copyright (c) 1990 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Lawrence Berkeley Laboratory,
 * Berkeley, CA.  The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

struct event {
	struct track *trk;
	u_long duration;	/* duration for notes (note off ommitted) */
	struct midi_msg m;
	struct event *next;
	struct event *pqnext;
};

extern struct event *ealloc();
extern void efree();
extern void efreel();
extern void dump_command();

extern struct event *pq_remove_bynote();
void pq_insert();

extern struct event *master_list;
extern struct event *raw_list;

#define evt_noteon_p(p) \
	(((p)->m.mm_cmd & 0xf0) == 0x90 && (p)->m.mm_data[2] != 0)

#define evt_noteoff_p(p) \
	(((p)->m.mm_cmd & 0xf0) == 0x80 || \
	 (((p)->m.mm_cmd & 0xf0) == 0x90 && (p)->m.mm_data[2] == 0))

