/*
 * Copyright (c) 1991 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Lawrence Berkeley Laboratory,
 * Berkeley, CA.  The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * @(#) $Header: bmdtrap.s,v 1.2 91/08/27 00:37:45 mccanne Exp $ (LBL)
 */

#ifndef BMD_CTRAP

#include <machine/trap.h>
#include <machine/clock.h>

#define CNTR_LIMIT14 0x0c

/*
 * From struct miditime defined in midiclk.h.
 */
#define MT_NOW		4
#define MT_WORK		8

	.global	_bmdtrap, _midiclk
_bmdtrap:
	! clear interrupt
	sethi	%hi(COUNTER_ADDR + CNTR_LIMIT14), %l3
	ld	[%l3 + %lo(COUNTER_ADDR + CNTR_LIMIT14)], %g0
	
	set	_midiclk, %l3
	ld	[%l3 + MT_NOW], %l4	! inc current time
	inc	%l4
	ld	[%l3 + MT_WORK], %l5	! if work to do call C handler
	cmp	%l4, %l5
	bl	1f
	st	%l4, [%l3 + MT_NOW]
	b	sys_trap
	mov	T_INTERRUPT|14, %l4	
1:
	mov	%l0, %psr
	nop
	nop
	jmp	%l1
	rett	%l2
#endif
